#!/usr/bin/python

# Author:  	Philip Cayting, Yale University
#			philip.cayting@yale.edu
# Function:  Allows customized export by field of the BreakDB data.

import cgi
import cgitb; cgitb.enable()
import SVEvent
import SVdB

HEADER_COLOR = "CCCCCC"
BODY_COLOR = "BFD7FE"
EXPORT_FORMATS = ["Tab-delimited", "FASTA"]

def fields_view():
	print "Content-type: text/html"
	print
	
	print "<a href=\"display.py\"><img src=\"svdb-header.gif\" border=0></a>"
	print "<font face=\"Arial, Helvetica, sans-serif\">"
	print "<H2>Custom Export</H2>"
	print "<P>Create a custom export of the breakpoint data in Break DB.  "
	print "Select the fields and file format you wish to export.</P>"
	
	print "<form action=\"custom_export.py\" method=\"get\">"
	print "<table width=800>"
	print "<TR><TD bgcolor=\"#%s\" COLSPAN=3><B>Export Fields</B></TD></TR>" % HEADER_COLOR
	for i, f in enumerate(SVEvent.EXPORT_FIELDS):
		full_name, field = f[0], f[1]
		if i % 2 == 0:
			print "<TR>"
		print "<TD bgcolor=\"#%s\" width=\"50%%\">&nbsp;<input type=\"checkbox\" name=\"field\" value=\"%s\" CHECKED>%s</TD>" % (BODY_COLOR, field, full_name)
		if i % 2 == 1:
			print "</TR>"
			
	print "<TR><TD bgcolor=\"#%s\" COLSPAN=3><B>File Format</B></TD></TR>" % HEADER_COLOR
	print "<TR><TD bgcolor=\"#%s\" COLSPAN=3><select name=\"format\">" % BODY_COLOR
	for valid_format in EXPORT_FORMATS:
		print "<option value=\"%s\">%s</option>" % (valid_format, valid_format)
	print "</select></td></tr>"
	print "</table>"
	print "<BR>"
	print "<input type=\"submit\" value=\"Export\">"
	print "</form>"
		
		
def export(form):
	if isinstance(form.getvalue("field"), list):
		fields = form.getvalue("field")
	else:
		fields = [form.getvalue("field"),]
	
	fields = formFieldList(fields, SVEvent.EXPORT_FIELDS)
	format = form.getfirst("format")
	conn = SVdB.getConnection()
							
	event_ids = SVdB.getEventIDs(0, 1000000, conn)
	
	if format == 'Tab-delimited':
		print 'Content-type: text/plain'
		print 
		
		# Print Header
		header = []
		for f in fields:
			header.append(f[0])
		print '\t'.join(header)
		for id in event_ids:
			e = SVEvent.ExistingSVEvent(id, conn)
			line = e.tabExport(fields)
			line = line.replace('\n', '')
			print line
	if format == 'FASTA':
		print 'Content-type: text/html'
		print
		print "FASTA export not yet implemented"
		
def formFieldList(field_values, full_fields):
	field_list = []
	for v in field_values:
		for f in full_fields:
			if v == f[1]:
				field_list.append(f)
	return field_list
	
	
	
# Main Execution	
form = cgi.FieldStorage()
if form.has_key('format'):
	export(form)
else:
	fields_view()

