#!/usr/bin/python

# Author:  	Philip Cayting, Yale University
#			philip.cayting@yale.edu
# Function:  Driving script for displaying BreakDB data.  Used to display
#  result list and individual Events.

import cgi
import cgitb; cgitb.enable()
from SVEvent import *
import SVdB

VARIANT_CELL_COLOR = "BFD7FE"
ARCHIVE_CELL_COLOR = "F7C3C3"

items_per_page = 30

def event_display(event_id, conn):
	print "Content-type: text/html"
	print
	
	print "<a href=\"display.py\"><img src=\"svdb-header.gif\" border=0></a>"
	print "<font face=\"Arial, Helvetica, sans-serif\">"
	print "<P><font size=+2><B>Event %s</B></font>" % (event_id)
	print "<BR><a href=\"edit.py?id=%s\"><img src=\"edit.gif\" border=0></a></P>" % (event_id)
	
	e = ExistingSVEvent(event_id, conn)
	
	print e.displayHTML(VARIANT_CELL_COLOR)
	
def archive_display(event_id, archive_number, conn):
	print "Content-type: text/html"
	print
	
	print "<a href=\"display.py\"><img src=\"svdb-header.gif\" border=0></a>"
	print "<font face=\"Arial, Helvetica, sans-serif\">"
	print "<H2>Archive %s.%s</H2>" % (event_id, archive_number)
	e = ArchiveSVEvent(event_id, archive_number, conn)
	
	print e.displayHTML(ARCHIVE_CELL_COLOR)
	
	
def display_all(index, conn, source_id=None):
	print "Content-type: text/html"
	print
	
	print "<img src=\"svdb-header.gif\"><P>"
	print "<font face=\"Arial, Helvetica, sans-serif\">"
	if source_id:
		print "<H2>%s</H2>" % SVdB.getSource(source_id, conn)[0]
	print "<table width=600>\n"
	(ids, total) = SVdB.getEventIDs(index, items_per_page, conn, source_id)
	for id in ids:
		print "<TR><TD bgcolor=\"#BFD7FE\"><A HREF=\"display.py?id=" + id + "\">" + id + "</A></TD></TR>\n"
	print "</table>"
	print "<BR>"
	print "<table width=400>"
	print "<TR><TD bgcolor=\"#CCCCCC\"><font size=-1>Records " + str(index + 1) + " - " + str(index+items_per_page+1) + " of " + str(total) + "&nbsp;</TD><TD bgcolor=\"#CCCCCC\"><font size=-1>"
	if source_id:
		print "<a href=\"display.py?next=%i&source=%i\">" % (index+items_per_page, source_id)
	else:
		print "<a href=\"display.py?next=%i\">" % (index+items_per_page)
	print "Next</a></td></tr></table>"
	

form = cgi.FieldStorage()
conn = SVdB.getConnection()
						
if form.has_key("archive"):
	archive_display(form.getfirst("id"),form.getfirst("archive"), conn)
elif form.has_key("id"):
	event_display(form.getfirst("id"), conn)
else:
	index = 0
	source=None
	if form.has_key("source"):
		source= int(form.getfirst("source"))
	if form.has_key("next"):
		index = int(form.getfirst("next"))
	display_all(index, conn, source_id=source)
