#!/usr/bin/python

# Author:  	Philip Cayting, Yale University
#			philip.cayting@yale.edu
# Function:  Exports entirety of BreakDB database into text files.  Generates
#  entire dump file and dump by source.  Designed to be run as a cron job.

import SVEvent
import SVdB

conn = SVdB.getConnection()

def output(eventIDs, file):
	delimiter = '\t'
	# Print Header
	header = []
	for field in SVEvent.EXPORT_FIELDS:
		header.append(field[0])
	file.write(delimiter.join(header)+"\n")
	
	for id in eventIDs:
		e = SVEvent.ExistingSVEvent(id, conn)
		line = e.tabExport(SVEvent.EXPORT_FIELDS)
		#line = line.replace("\n", "")
		file.write(line)
		
# Write Entire DB Output
file = open('/home/gersteinlab/sv.gersteinlab.org/breakdb/breakdb.txt', 'w')
output(SVdB.getEventIDs(0, 1000000000, conn)[0], file)
file.close()
# Write By Source
for (source_name, source_id, count) in SVdB.getAllSources(conn):
	file = open('/home/gersteinlab/sv.gersteinlab.org/breakdb/breakdb_%i.txt' % source_id, 'w')
	output(SVdB.getEventIDs(0, 100000000, conn, source_id=source_id)[0], file)
	file.close()
	

