#!/usr/bin/python

# Author:  	Philip Cayting, Yale University
#			philip.cayting@yale.edu
# Function:  Displays Read data

import SVdB
import cgi
import cgitb; cgitb.enable()

conn = SVdB.getConnection()

cell_color = "BFD7FE"

def printStartRow():
	return "<tr>"
	
def printEndRow():
	return "</tr>"
	
def printStartSection():
	return "<td valign=top style=\"word-break:break-all\"><table width=\"350\" border=0>"
	
def printEndSection():
	return "</table></td>"
	
def printTableHeader(title):
	return "<tr><td bgcolor=\"#CCCCCC\"><B>" + str(title) + "</B></td></tr>"
	
def printTableData(cell_color, data):
	if not data: data = '--'
	return "<tr><td bgcolor=\"#%s\">%s</td></tr>" % (cell_color, data)
		
def printBlankLine():
	return "<tr><td>&nbsp;</td></tr>"

def displayError(error_message):
	print "Content-type: text/html"
	print
	print "<a href=\"display.py\"><img src=\"svdb-header.gif\" border=0></a>"
	print "<font face=\"Arial, Helvetica, sans-serif\">"
	
	print "<H2>%s</H2>" % error_message

def displayReadPair(rp):
	print "Content-type: text/html"
	print
	print "<a href=\"display.py\"><img src=\"svdb-header.gif\" border=0></a>"
	print "<font face=\"Arial, Helvetica, sans-serif\">"
	
	print "<P><B><font size=\"+2\">Read %s</font></B></P>" % rp.name
	print "<table width=800 border=0>"
	print printStartRow()
	print printStartSection()
	print printTableHeader("Left Read")
	print printTableData(cell_color, rp.left_read.read_name)
	print printBlankLine()
	print printEndSection()
	print printStartSection()
	print printTableHeader("Right Read")
	print printTableData(cell_color, rp.right_read.read_name)
	print printBlankLine()
	print printEndSection()
	print printEndRow()

	
	print printStartRow()
	print printStartSection()
	print printTableHeader("Mapped Location")
	print printTableData(cell_color, rp.left_read.coordString())
	print printBlankLine()
	print printEndSection()
	print printStartSection()
	print printTableHeader("Mapped Location")
	print printTableData(cell_color, rp.right_read.coordString())
	print printBlankLine()
	print printEndSection()
	print printEndRow()

	
	print printStartRow()
	print printStartSection()
	print printTableHeader("Sequence")
	print printTableData(cell_color, rp.left_read.sequence)
	print printBlankLine()
	print printEndSection()
	print printStartSection()
	print printTableHeader("Sequence")
	print printTableData(cell_color, rp.right_read.sequence)
	print printBlankLine()
	print printEndSection()
	print printEndRow()

	print "</table>"
	
form = cgi.FieldStorage()
if form.has_key('id'):
	rp = SVdB.getReadPair(int(form.getfirst("id")), conn)
	if not rp: displayError("Invalid Read ID")
	else: displayReadPair(rp)
else:
	displayError("Must provide Read ID")