#!/usr/bin/perl -w
use strict;

my $max_size_difference= 0.25;

my @list_of_previous_SVs_validated = (
        #"Human/NA15510/validation_candidates/calls_070215_na15510.cluster.deletion_primers_delinsnew_hg18.csv.gz",
		#"Human/NA15510/validation_candidates/pcr_primers_initial_try_hg18.csv.gz",
		#"Human/NA15510/validation_candidates/validations_deletions_from_feb7th_dist3_hg17.csv.gz",
		#"Human/NA15510/validation_candidates/validations_deletions_singletons_from_feb7th_10k-100k_hg17.csv.gz",
		#"Human/NA18505/validation_candidates/NA18505_as_of_070411_hg18.csv.gz",
		#"Human/NA18505/validation_candidates/070411_NA18505_singletons.csv.gz",
		#"Human/NA18505/validation_candidates070423_NA18505_deletions_insertions_inversions.csv.gz",
);												

my $build='36';
my $median_insert_size = 3007;
my $number_of_Ns = 20000;
my $overlap_extension = 2000;
my $uncertainty =5000;
unless (@ARGV) {
	print STDERR "parameters: infile\n";
	print STDERR "    --> careful, sorts out cases where within a cluster target regions are dimished, thus numbers may not match perfrectly; see line XXXIMPXXX!\n";
	exit;
}

my $bp_window_overlap=500;
my $indel_reporting_threshold=50;

my ($infile, $new_build, $insert_size, $newuncertainty) =@ARGV;
$build = $new_build if ($new_build);
$uncertainty = $newuncertainty if ($newuncertainty);
$median_insert_size = $insert_size if ($insert_size);
print STDERR "#using build: $build!!!\n" if ($build =~ /35/);

#-- main
my (%STARTs,%ENDs, %presence, %IDs);
#&parse_previous_validation_lists(@list_of_previous_SVs_validated);
&parse_infile($infile);


#-- subs
sub parse_infile {
	my ($file) = @_;
	if ($file =~ /\.gz$/) {
		open FH, "gunzip -c $file |";
	} else {
		open FH, "$file" or die "cannot open $file : $!\n";
	}
	my $OK=0;
	my $cluster;
	my $ignore_complex;
	my $target_interval_start=0;
	my $chr;
	my $count_pred=0;
	my $first_start = 10000000000000000;
	my $last_end=0;
	my $uniq_score =0;
	my $HS_score;
	my @NEWIDs;
	my $delcnt=0;my $inscnt=0; my $comcnt=0;
	my ($mean_start,$mean_end,$mean_count);
	my $target_interval_end=10000000000000000000;
	my (@DEL_IDs, @DELs, @COMs, @COM_IDs, @OTHERS, @INS_COM_IDs, @INS_COM);
	while (<FH>) {
		chomp;
		next if ($_ =~ /highest_score/);
		if ($_ =~ /^\#>(.*) \(max.*HS\-Stringency\-Score=([0-9]+)/) {
			my ($save, $newHS_score)=($1,$2);
			if (!$ignore_complex and $cluster) {
					#my $estimated_size = $target_interval_end + int(($last_end-$target_interval_end)/2) - (int (($target_interval_start-$first_start)/2) + $first_start) - $median_insert_size;
					my $median_start = $first_start + int (($target_interval_start-$first_start)/2);
                    my $median_end = $target_interval_end + int (($last_end-$target_interval_end)/2);
					my $estimated_size = abs($median_end-$median_start-1-$median_insert_size);#XXX
					$estimated_size = $median_insert_size-($median_end-$median_start)  if ($cluster =~ /Insertion\-Cluster/);
					if ($cluster =~ /^Del/) {
						push (@DELs, ">$cluster $chr:$target_interval_start-$target_interval_end (overlapping_paired_ends=$count_pred; intervals=$first_start-$target_interval_start|$target_interval_end-$last_end; estimated size of SV=$estimated_size; HS-score=$HS_score; Uniqueness-Qual-Score=$uniq_score \[score_of_at_least_4_is_very_high_qual\])  \n");
						push (@{$DEL_IDs[$delcnt]}, @NEWIDs);
						$delcnt++;
					} elsif ($cluster =~ /^Com/) {
						$estimated_size = 'NA';
						push (@COMs, ">$cluster $chr:$first_start-$last_end (overlapping_paired_ends=$count_pred; intervals=$first_start-$target_interval_start|$target_interval_end-$last_end; estimated size of SV=$estimated_size; HS-score=$HS_score; Uniqueness-Qual-Score=$uniq_score \[score_of_at_least_4_is_very_high_qual\])  \n");
						push (@{$COM_IDs[$comcnt]}, @NEWIDs);
						$comcnt++;
					} elsif ($cluster =~ /Com/) {
						push (@INS_COM, ">$cluster $chr:$first_start-$last_end (overlapping_paired_ends=$count_pred; intervals=$first_start-$target_interval_start|$target_interval_end-$last_end; estimated size of SV=$estimated_size; HS-score=$HS_score; Uniqueness-Qual-Score=$uniq_score \[score_of_at_least_4_is_very_high_qual\])  \n");
						push (@OTHERS, ">$cluster $chr:$first_start-$last_end (overlapping_paired_ends=$count_pred; intervals=$first_start-$target_interval_start|$target_interval_end-$last_end; estimated size of SV=$estimated_size; HS-score=$HS_score; Uniqueness-Qual-Score=$uniq_score \[score_of_at_least_4_is_very_high_qual\])  \n");
						push (@{$INS_COM_IDs[$inscnt]}, @NEWIDs);
						$inscnt++;
					} elsif ($cluster =~ /\-L\+/) {
						push (@OTHERS, ">$cluster $chr:$target_interval_start-$last_end (overlapping_paired_ends=$count_pred; intervals=$first_start-$target_interval_start|$target_interval_end-$last_end; estimated size of SV=$estimated_size; HS-score=$HS_score; Uniqueness-Qual-Score=$uniq_score \[score_of_at_least_4_is_very_high_qual\])  \n");
					} elsif ($cluster =~ /\+L\-/) {
						push (@OTHERS, ">$cluster $chr:$first_start-$target_interval_end (overlapping_paired_ends=$count_pred; intervals=$first_start-$target_interval_start|$target_interval_end-$last_end; estimated size of SV=$estimated_size; HS-score=$HS_score; Uniqueness-Qual-Score=$uniq_score \[score_of_at_least_4_is_very_high_qual\])  \n");
					} else {
						push (@OTHERS, ">$cluster $chr:$target_interval_start-$target_interval_end (overlapping_paired_ends=$count_pred; intervals=$first_start-$target_interval_start|$target_interval_end-$last_end; estimated size of SV=$estimated_size; HS-score=$HS_score; Uniqueness-Qual-Score=$uniq_score \[score_of_at_least_4_is_very_high_qual\])  \n");
					}
					$mean_start=$mean_end=$mean_count=0;
					@NEWIDs=();
					#next;#XXX
					#print " median_coord=$chr:$median_start-$median_end; ";
					#my $celera_validated = &RunBlatvsSameChromosomeOnCelera ($cluster, $chr, $median_start, $median_end, $estimated_size);
					#my $test_overlap = &prepare_primer_design($cluster,$chr,$first_start,$target_interval_start,$target_interval_end,$last_end,$estimated_size, $overlap_extension) unless ($celera_validated);
					#print STDERR "second return: $test_overlap\n";
					#print " [no_primers;already previously designed=$test_overlap]" if ($test_overlap);
					#print "\n";
					#print STDERR "DONE with primer...\n";
			} elsif ($ignore_complex and $cluster) {
					$mean_start = int ($mean_start/$mean_count);
					$mean_end = int ($mean_end/$mean_count);
					my $estimated_size = abs ($mean_end-$mean_start-1-$median_insert_size);
					#my $estimated_size = abs($median_end-$median_start-1-$median_insert_size);#XXX
					$estimated_size = $median_insert_size-($mean_end-$mean_start)  if ($cluster =~ /Insertion\-Cluster/);
					if ($cluster =~ /^Del/) {
						push (@DELs, ">$cluster $chr:$mean_start-$mean_end (overlapping_paired_ends=$count_pred; intervals=$first_start-$target_interval_start|$target_interval_end-$last_end; estimated size of SV=$estimated_size; HS-score=$HS_score; Uniqueness-Qual-Score=$uniq_score \[score_of_at_least_4_is_very_high_qual\])  \n");
						push (@{$DEL_IDs[$delcnt]}, @NEWIDs);
						$delcnt++;
					} elsif ($cluster =~ /^Com/) {
						$estimated_size = 'NA';
						push (@COMs, ">$cluster $chr:$mean_start-$mean_end (overlapping_paired_ends=$count_pred; intervals=$first_start-$target_interval_start|$target_interval_end-$last_end; estimated size of SV=$estimated_size; HS-score=$HS_score; Uniqueness-Qual-Score=$uniq_score \[score_of_at_least_4_is_very_high_qual\])  \n");
						push (@{$COM_IDs[$comcnt]}, @NEWIDs);
						$comcnt++;
					} elsif ($cluster =~ /Com/) {
						push (@INS_COM, ">$cluster $chr:$mean_start-$mean_end (overlapping_paired_ends=$count_pred; intervals=$first_start-$target_interval_start|$target_interval_end-$last_end; estimated size of SV=$estimated_size; HS-score=$HS_score; Uniqueness-Qual-Score=$uniq_score \[score_of_at_least_4_is_very_high_qual\])  \n");
						push (@OTHERS, ">$cluster $chr:$mean_start-$mean_end (overlapping_paired_ends=$count_pred; intervals=$first_start-$target_interval_start|$target_interval_end-$last_end; estimated size of SV=$estimated_size; HS-score=$HS_score; Uniqueness-Qual-Score=$uniq_score \[score_of_at_least_4_is_very_high_qual\])  \n");
						push (@{$INS_COM_IDs[$inscnt]}, @NEWIDs);
						$inscnt++;
					} else {
						push (@OTHERS, ">$cluster $chr:$mean_start-$mean_end (overlapping_paired_ends=$count_pred; intervals=$first_start-$target_interval_start|$target_interval_end-$last_end; estimated size of SV=$estimated_size; HS-score=$HS_score; Uniqueness-Qual-Score=$uniq_score \[score_of_at_least_4_is_very_high_qual\])  \n");
					}																						
					$mean_start=$mean_end=$mean_count=0;
					@NEWIDs=();
			}
			
			$cluster = $save;
			#print STDERR "$cluster\n";
			$count_pred=0;
			$ignore_complex = 0;
			$first_start = 10000000000000000;
			$last_end=0;
			$target_interval_start=0;
			$target_interval_end=10000000000000000000;
			$uniq_score =0;
			$HS_score = $newHS_score;
		} elsif ($_ =~ /chr/) {
			my ($id, $sc, $chrA, $startA, $endA, $strandA, $percIDA, undef, $chrB, $startB, $endB,$strandB, $percIDB) = split;
			#print STDERR "$id, $sc, $chrA, $startA, $endA, $strandA, $percIDA, undef, $chrB, $startB, $endB, $strandB, $percIDB\n";
			if ($chrA ne $chrB) {
				if ($chrA and $chrB) {
				                   print STDERR "transloc = unimplemented! [in line: $_]\n";
				                   die;
				               } else {
				                   print STDERR "warning: strange line: \"$_\" in $file ... (ignoring)\n";
				                   next;
				}
				#print STDERR "transloc = unimplemented! [in line: $_]\n";
				#die;
			}
			my (@sorted) = sort {$a <=> $b} ($startA, $endA, $startB, $endB); #von klein nach gross...
			push (@NEWIDs, $id);
			#print STDERR "@sorted\n";
			$count_pred++;
			$uniq_score+=2 if ($_ =~ /\=2\]/);
			$first_start =  $sorted[0] if ($sorted[0]<$first_start);
			$target_interval_start = $sorted[1] if ($sorted[1]>$target_interval_start);
			$target_interval_end = $sorted[2] if ($sorted[2]<$target_interval_end);
			$last_end =  $sorted[3] if ($sorted[3]>$last_end);
			#print STDERR "Interval $chrA:$target_interval_start-$target_interval_end\n";
			$ignore_complex = 1 if ($target_interval_start > $target_interval_end); #XXXIMPXXX  additional filter XXX
			$chr=$chrA;
			$mean_start+=$sorted[1];
            $mean_end+=$sorted[2];
	        $mean_count++;
		}
	}
	#return;#XXX
	if (!$ignore_complex and $cluster) {
		my $median_start = $first_start + int (($target_interval_start-$first_start)/2);
		my $median_end = $target_interval_end + int (($last_end-$target_interval_end)/2);
		my $estimated_size = $median_end-$median_start-1-$median_insert_size;
		#print ">$cluster $chr:$target_interval_start-$target_interval_end (overlapping_paired_ends=$count_pred; intervals=$first_start-$target_interval_start|$target_interval_end-$last_end; estimated size of SV=$estimated_size; HS-score=$HS_score; Uniqueness-Qual-Score=$uniq_score \[score_of_at_least_4_is_very_high_qual\])  ";
		#print " median_coord=$chr:$median_start-$median_end; \n";
		if ($cluster =~ /^Del/) {
						push (@DELs, ">$cluster $chr:$target_interval_start-$target_interval_end (overlapping_paired_ends=$count_pred; intervals=$first_start-$target_interval_start|$target_interval_end-$last_end; estimated size of SV=$estimated_size; HS-score=$HS_score; Uniqueness-Qual-Score=$uniq_score \[score_of_at_least_4_is_very_high_qual\])  \n");
						push (@{$DEL_IDs[$delcnt]}, @NEWIDs);
						$delcnt++;
					} elsif ($cluster =~ /^Com/) {
						push (@COMs, ">$cluster $chr:$target_interval_start-$target_interval_end (overlapping_paired_ends=$count_pred; intervals=$first_start-$target_interval_start|$target_interval_end-$last_end; estimated size of SV=$estimated_size; HS-score=$HS_score; Uniqueness-Qual-Score=$uniq_score \[score_of_at_least_4_is_very_high_qual\])  \n");
						push (@{$COM_IDs[$comcnt]}, @NEWIDs);
						$comcnt++;
					} elsif ($cluster =~ /Com/) {
						push (@INS_COM, ">$cluster $chr:$target_interval_start-$target_interval_end (overlapping_paired_ends=$count_pred; intervals=$first_start-$target_interval_start|$target_interval_end-$last_end; estimated size of SV=$estimated_size; HS-score=$HS_score; Uniqueness-Qual-Score=$uniq_score \[score_of_at_least_4_is_very_high_qual\])  \n");
						push (@OTHERS, ">$cluster $chr:$target_interval_start-$target_interval_end (overlapping_paired_ends=$count_pred; intervals=$first_start-$target_interval_start|$target_interval_end-$last_end; estimated size of SV=$estimated_size; HS-score=$HS_score; Uniqueness-Qual-Score=$uniq_score \[score_of_at_least_4_is_very_high_qual\])  \n");
						push (@{$INS_COM_IDs[$inscnt]}, @NEWIDs);
						$inscnt++;
					} else {
						push (@OTHERS, ">$cluster $chr:$target_interval_start-$target_interval_end (overlapping_paired_ends=$count_pred; intervals=$first_start-$target_interval_start|$target_interval_end-$last_end; estimated size of SV=$estimated_size; HS-score=$HS_score; Uniqueness-Qual-Score=$uniq_score \[score_of_at_least_4_is_very_high_qual\])  \n");
		}
		#my $celera_validated = &RunBlatvsSameChromosomeOnCelera ($cluster, $chr, $median_start, $median_end, $estimated_size);
		#my $test_overlap = &prepare_primer_design($cluster,$chr,$first_start,$target_interval_start,$target_interval_end,$last_end,$estimated_size, $overlap_extension) unless ($celera_validated);
		#print " [no_primers;already previously designed=$test_overlap]" if ($test_overlap);
		#print "\n";																																			
	} elsif ($ignore_complex and $cluster) {
		$mean_start = int ($mean_start/$mean_count);
		$mean_end = int ($mean_end/$mean_count);
		my $estimated_size = abs ($mean_end-$mean_start-1-$median_insert_size);
		#my $estimated_size = abs($median_end-$median_start-1-$median_insert_size);#XXX
		$estimated_size = $median_insert_size-($mean_end-$mean_start)  if ($cluster =~ /Insertion\-Cluster/);
		if ($cluster =~ /^Del/) {
			push (@DELs, ">$cluster $chr:$mean_start-$mean_end (overlapping_paired_ends=$count_pred; intervals=$first_start-$target_interval_start|$target_interval_end-$last_end; estimated size of SV=$estimated_size; HS-score=$HS_score; Uniqueness-Qual-Score=$uniq_score \[score_of_at_least_4_is_very_high_qual\])  \n");
			push (@{$DEL_IDs[$delcnt]}, @NEWIDs);
			$delcnt++;
		} elsif ($cluster =~ /^Com/) {
			$estimated_size = 'NA';
			push (@COMs, ">$cluster $chr:$mean_start-$mean_end (overlapping_paired_ends=$count_pred; intervals=$first_start-$target_interval_start|$target_interval_end-$last_end; estimated size of SV=$estimated_size; HS-score=$HS_score; Uniqueness-Qual-Score=$uniq_score \[score_of_at_least_4_is_very_high_qual\])  \n");
			push (@{$COM_IDs[$comcnt]}, @NEWIDs);
			$comcnt++;
		} elsif ($cluster =~ /Com/) {
			push (@INS_COM, ">$cluster $chr:$mean_start-$mean_end (overlapping_paired_ends=$count_pred; intervals=$first_start-$target_interval_start|$target_interval_end-$last_end; estimated size of SV=$estimated_size; HS-score=$HS_score; Uniqueness-Qual-Score=$uniq_score \[score_of_at_least_4_is_very_high_qual\])  \n");
			push (@OTHERS, ">$cluster $chr:$mean_start-$mean_end (overlapping_paired_ends=$count_pred; intervals=$first_start-$target_interval_start|$target_interval_end-$last_end; estimated size of SV=$estimated_size; HS-score=$HS_score; Uniqueness-Qual-Score=$uniq_score \[score_of_at_least_4_is_very_high_qual\])  \n");
			push (@{$INS_COM_IDs[$inscnt]}, @NEWIDs);
			$inscnt++;
		} else {
			push (@OTHERS, ">$cluster $chr:$mean_start-$mean_end (overlapping_paired_ends=$count_pred; intervals=$first_start-$target_interval_start|$target_interval_end-$last_end; estimated size of SV=$estimated_size; HS-score=$HS_score; Uniqueness-Qual-Score=$uniq_score \[score_of_at_least_4_is_very_high_qual\])  \n");
		}
		$mean_start=$mean_end=$mean_count=0;
		@NEWIDs=();
	}								
	#-- output
	print STDERR "checking overlaps deletions!\n";
	for (my $i=0; $i<@DELs; $i++) {
		#-- test overlap
		#print STDERR "hi:$DELs[$i]\n";
		my $match =0;
		for (my $y=0; $y<@INS_COM; $y++) {
			#print STDERR "hi:$INS_COM[$y]  -- $i \n";
			#print STDERR "hi:$INS_COM[$y]  -- $i @{$DEL_IDs[$i]}\n";
			#my $match =0;
			foreach my $delid (@{$DEL_IDs[$i]}) {
				#print STDERR "hallo:$delid\n";
				foreach my $insid (@{$INS_COM_IDs[$y]}) {
					#print STDERR "found match: Del: $delid Ins: $insid   **** $DELs[$i] ****  $INS_COM[$i]\n" if ($delid eq $insid) ;
					$match=1 if ($delid eq $insid);
					last if ($match);
				}
				last if ($match);
			}
			last if ($match);
		}
		print "$DELs[$i]" unless ($match);
		
	}
	print STDERR "checking overlaps complex unmated!\n";
	for (my $i=0; $i<@COMs; $i++) {
		#-- test overlap
		#print STDERR "hi:$DELs[$i]\n";
		my $match =0;
		for (my $y=0; $y<@INS_COM; $y++) {
			#print STDERR "hi:$INS_COM[$y]  -- $i \n";
			#print STDERR "hi:$INS_COM[$y]  -- $i @{$DEL_IDs[$i]}\n";
			#my $match =0;
			foreach my $comlid (@{$COM_IDs[$i]}) {
				#print STDERR "hallo:$delid\n";
				foreach my $insid (@{$INS_COM_IDs[$y]}) {
					#print STDERR "found match: Del: $delid Ins: $insid   **** $DELs[$i] ****  $INS_COM[$i]\n" if ($delid eq $insid) ;
					$match=1 if ($comlid eq $insid);
					last if ($match);
				}
				last if ($match);
			}
			last if ($match);
		}
		print "$COMs[$i]" unless ($match);
		
	}
	#-- do all the rest
	for (my $i=0; $i<@OTHERS; $i++) {
		print "$OTHERS[$i]";
	}
}
		
		
		

sub prepare_primer_design {
	my ($cluster, $chr,$first_start,$target_interval_start,$target_interval_end,$last_end,$estimated_size, $overlap_extension) = @_;
	my ($script_used, $SEQ);
	if ($build eq '35') {
		$script_used = "/home/korbel/Sauron/Projects/PairedEnd/Perl/build35_tools/coordinates2fasta_hg17.pl";
	} elsif ($build eq '36') {
		$script_used = "/home/korbel/Sauron/Projects/PairedEnd/Perl/coordinates2fasta_hg18.pl";
	} else {
		print STDERR "build not allowed currently!\n";
		die;
	}
	
	
	if ($cluster =~ /^Del/) {
		#if (abs($target_interval_start-$first_start) >= ($number_of_Ns-2*$overlap_extension) or abs($last_end-$target_interval_end) >= ($number_of_Ns-2*$overlap_extension)) {# arbitray; fixed at 8000
		#	print "#ignoring $cluster, $chr,$first_start,$target_interval_start,$target_interval_end,$last_end,$estimated_size --> too large interval at boundaries!";
		#	return;
		#}
		my $overlap = &intersect ('DEL',$chr,$target_interval_start,$target_interval_end);
		return $overlap if ($overlap); #primer designed before
		my $new_start=$first_start-$overlap_extension;
		my $seq_A = `$script_used $chr $new_start $target_interval_start y | grep -v '>'`;
		my $new_end=$last_end+$overlap_extension;
		my $seq_B = `$script_used $chr $target_interval_end $new_end y | grep -v '>'`;
		$SEQ =  $seq_A;
		for (my $i=0; $i<$number_of_Ns/10; $i++) {$SEQ .= "NNNNNNNNNN"};# does $number_of_Ns N's
		$SEQ .= "\n$seq_B";
		#print "$SEQ\n";
	} elsif ($cluster =~ /^Ins/) {
	        #if (abs($target_interval_start-$first_start) >= ($number_of_Ns-2*$overlap_extension) or abs($last_end-$target_interval_end) >= ($number_of_Ns-2*$overlap_extension)) { # arbitray; fixed at 8000
	        #    print "#ignoring $cluster, $chr,$first_start,$target_interval_start,$target_interval_end,$last_end,$estimated_size --> too large interval at boundaries!";
	        #    return;
		    #}
			my $overlap = &intersect ('INS',$chr,$target_interval_start,$target_interval_end);
			return $overlap if ($overlap); #primer designed before
			my $new_start=$first_start-$overlap_extension;
			my $seq_A = `$script_used $chr $new_start $target_interval_start y | grep -v '>'`;
			my $new_end=$last_end+$overlap_extension;
			my $seq_B = `$script_used $chr $target_interval_end $new_end y | grep -v '>'`;
			$SEQ =  $seq_A;
			for (my $i=0; $i<$number_of_Ns/10; $i++) {$SEQ .= "NNNNNNNNNN"};# does $number_of_Ns N's
			$SEQ .= "\n$seq_B";
			#print "$SEQ\n";
	}  elsif ($cluster =~ /^Inversion\(\-L\+\)/) {
	            #-case A
			my $overlap = &intersect ('INV',$chr,$target_interval_start,$target_interval_end);
			return $overlap if ($overlap); #primer designed before
			my $new_start=$first_start-$overlap_extension;
			my $seq_A = `$script_used $chr $new_start $target_interval_start y | grep -v '>'`;
			my $new_end=$last_end; #unchanged (reason: size of deletion unknown; could erroneously go over 2nd breakpoint and screw up result! i.e. false positive rate)
			my $seq_B = `$script_used $chr $target_interval_end $new_end y 1 | grep -v '>'`; #get revcom of non-extended sequence!
			$SEQ =  $seq_A;
			for (my $i=0; $i<$number_of_Ns/10; $i++) {$SEQ .= "NNNNNNNNNN"};# does $number_of_Ns N's
				$SEQ .= "\n$seq_B";
				#print "$SEQ\n";
				open WH, "> .dat_primer.$$.fa" or die;
				my $seq_size = length($SEQ);
				print WH ">$chr:$target_interval_start-$target_interval_end\n$SEQ";
				close WH;
				&iterative_primer_design(".dat_primer.$$.fa", $cluster, $chr,$first_start,$target_interval_start,$target_interval_end,$last_end,$estimated_size, $seq_size);
			
	} elsif ($cluster =~ /^Inversion\(\+L\-\)/) {
	#-case B
		my $overlap = &intersect ('INV',$chr,$target_interval_start,$target_interval_end);
		return $overlap if ($overlap); #primer designed before
		my $new_start=$first_start;#unchanged (reason: size of deletion unknown; could erroneously go over 2nd breakpoint and screw up result! i.e. false positive rate)
		my $seq_A = `$script_used $chr $new_start $target_interval_start y 1 | grep -v '>'`; #get revcom of non-extended sequence!
		my $new_end=$last_end+$overlap_extension;
		my $seq_B = `$script_used $chr $target_interval_end $new_end y | grep -v '>'`;
		$SEQ =  $seq_A;
		for (my $i=0; $i<$number_of_Ns/10; $i++) {$SEQ .= "NNNNNNNNNN"};# does $number_of_Ns N's
			$SEQ .= "\n$seq_B";
			#print "$SEQ\n";
			open WH, "> .dat_primer.$$.fa" or die;
			my $seq_size = length($SEQ);
			print WH ">$chr:$target_interval_start-$target_interval_end\n$SEQ";
			close WH;
			&iterative_primer_design_inv(".dat_primer.$$.fa", $cluster, $chr,$first_start,$target_interval_start,$target_interval_end,$last_end,$estimated_size, $seq_size);
	}
	
	#--design primers for non-inversions
	unless ($cluster =~ /^Inv/) { #only programmed like this, as more convenient
		open WH, "> .dat_primer.$$.fa" or die;
		my $seq_size = length($SEQ);
		print WH ">$chr:$target_interval_start-$target_interval_end\n$SEQ";
		close WH;
		&iterative_primer_design_inv(".dat_primer.$$.fa", $cluster, $chr,$first_start,$target_interval_start,$target_interval_end,$last_end,$estimated_size, $seq_size);
	}
	system "rm -rf .dat_primer.$$.fa*";
	return (0);
}

sub iterative_primer_design {
	my ($infile, $cluster, $chr,$first_start,$target_interval_start,$target_interval_end,$last_end,$estimated_size, $seq_size) =@_;
	my $OK=0;
	my $min_product_size = $number_of_Ns;
	my $max_product_size = $number_of_Ns + 1000;
	my ($left, $right);
	while (!$OK) {
	  #-- 1. create input file
		#print STDERR "Running primer3 iteration $chr:$target_interval_start-$target_interval_end with product size $min_product_size-$max_product_size...\n";
		system "./Perl/formatPrimer3_for_SV_validation.pl -i $infile -PRIMER_PRODUCT_SIZE_RANGE $min_product_size-$max_product_size > $infile.prim3_in";
		
	  #-- 2. run primer3	
		system "~/bin/primer3_core < $infile.prim3_in > $infile.prim3_out";	
		
	  #-- 3. parse output
		open FH2, "$infile.prim3_out" or die;
		my ($leftP, $rightP);
		while (<FH2>) {
			chomp;
			if ($_ =~ /PRIMER_LEFT_SEQUENCE\=([ACGTacgt]+)/) {
				$left = $1;
			} elsif ($_ =~ /PRIMER_RIGHT_SEQUENCE\=([ACGTacgt]+)/) {
				$right = $1;
			}
		}
	  	if ($left and $right) {
			my $expected_band_size_L = $median_insert_size + (($max_product_size - $number_of_Ns ) / 2) - int(($target_interval_start-$first_start)/2) - int(($last_end-$target_interval_end)/2);
			my $expected_band_size_S = $expected_band_size_L-2000;
			$expected_band_size_S = 0 if ($expected_band_size_S < 0);
			$expected_band_size_L = 1000 if ($expected_band_size_L < 1000);
			print " LEFT=$left; RIGHT=$right; EXP_BAND_SIZE=$expected_band_size_S-$expected_band_size_L";
			last;
		} else {
			$left=undef; $right=undef;
		}
	  #-- 4.. next iteration
		$max_product_size+=1000;
		if ($max_product_size>$seq_size) {
			print "#stopping prematurely, as max_product_size>seq_size --> may wanna improve this by getting more quality (non-repeat)-sequence to left and right!!\n";
			last;
		}
		close FH2;
	}
    #die;	
}

sub RunBlatvsSameChromosomeOnCelera {
	my ($cluster, $chr, $median_start, $median_end, $estimated_size)=@_;
	my $gap_warning=0;
	my $missing_seq_warning=0;
	my $validated;
	#print ">Getting flanking sequences for $size-bp-SV ($cluster) $chr:$median_start-$median_end (and trying to blat vs. $chr on different builds; overlap=$bp_window_overlap)";
	#print " [$FullLabel{$size}[$i]]" if ($singleton_mode);
	#print "\n";
	my $new_start = $median_start-$bp_window_overlap;
	my $new_end = $median_end+$bp_window_overlap;
	$new_start = 1 if ($new_start<1);
	my $seq1 = `Perl/coordinates2fasta_hg18.pl  $chr  $new_start  $median_start y | grep -v '>'`; # lef
	my $seq2 = `Perl/coordinates2fasta_hg18.pl  $chr  $median_end $new_end y | grep -v '>'`; # right
    my $seq = ">comb\n" . $seq1 . $seq2;
    if ($seq =~ /([Nn]+)/) {
		print "#***GAP-warning***# (Sequence contains at least ", length($1), " Ns.)\n";
		$gap_warning = 1;
	}
	
	my $max_intron="";
	if (abs($new_start-$new_end)>750000) {
		$max_intron=sprintf "-maxIntron=%d", abs($new_start-$new_end);
	}
	my ($start_match, $end_match, $strand, $ad_hoc_score,$T_ST,$T_E);
    
	#-- (1) Cmp vs. Celera
	my $Celera_chr = $chr;
	$Celera_chr =~ s/chr/celera.chromosome/;
	my $run = "echo \"$seq\" | nice ~/bin/blat/blat-x86_64-suse-linux Data/Celera_Human/$Celera_chr.2bit stdin -ooc=Data/Celera_Human/celera_human_all_sequences.11.ooc stdout -noHead $max_intron -extendThroughN";
	#print STDERR "$run\n";
	my $out = `$run`;
	my ($Q_ST,$Q_E);
	($Q_ST,$Q_E,$T_ST,$T_E,$start_match, $end_match) = (0,0,0,0,0,0);
	$ad_hoc_score=0;
	foreach my $line (split (/\n/, $out)) {
		my ($match_bp,$mismatch_bp, $rep, $Ns, $Qgap_count, $Qgap_bp,$Tgap_count, $Tgap_bp, $res_strand, $Qname, $Qsize, $Qstart,$Qend,$Tname,$Tsize,$Tstart,$Tend,undef, undef, $Qstarts, $Tstarts)  = split (/\t/, $line);
		if (!$ad_hoc_score) {
			$ad_hoc_score = $match_bp-$mismatch_bp-($Qgap_count+$Tgap_count)*0.8;
			$start_match = $Tstart+$bp_window_overlap+1;
			$end_match = $start_match + $Tend - $Tstart;
			$strand = $res_strand;
			($T_ST,$T_E)=($Tstart, $Tend);
			($Q_ST,$Q_E)=($Qstart, $Qend);
		} else {
			if ($Qstart<$Q_ST or $Qend>$Q_E) {#must overlap
				($Q_ST,undef,undef,$Q_E)=sort {$a<=>$b} ($Q_ST,$Q_E,$Qstart, $Qend);
				($T_ST,undef,undef,$T_E)=sort {$a<=>$b} ($T_ST,$T_E,$Tstart, $Tend);
				$ad_hoc_score+=$match_bp-$mismatch_bp-($Qgap_count+$Tgap_count)*0.8;
				($start_match) = sort {$a<=>$b} ($start_match,($Tstart+$bp_window_overlap+1));
				($end_match) = sort {$b<=>$a} ($end_match,($start_match + $Tend - $Tstart));
				$strand .= "/$res_strand";
			}
		}
		$ad_hoc_score/=(2*$bp_window_overlap);
		$ad_hoc_score = 1 if ($ad_hoc_score>1); #can sometimes be slightly higher than 1
		#print ">>$Q_ST-$Q_E\n";
		#print "$line\n";
		last if (($Q_E-$Q_ST) > 0.9*2*$bp_window_overlap);#90% match, should not be called inversion then
	}
	if (($Q_E-$Q_ST) < 0.9*2*$bp_window_overlap) {
		$missing_seq_warning=1;
	}
	#print "$out\n";
	print " [BLAT alignment_stats: celera-$chr:",$start_match+500,"-",$end_match-500,"; ",$T_E-$T_ST-2-2*$bp_window_overlap," bp; strands(s) $strand; ad_hoc_score=$ad_hoc_score]";
	#-- report indels
	if (abs (($T_E-$T_ST-1-2*$bp_window_overlap)-($median_end-$median_start-1)) >= $indel_reporting_threshold) {
		if ($strand eq '-' or $strand eq '+') {
			print " [Found-BLAT-indel=", -1* (($T_E-$T_ST-1-2*$bp_window_overlap)-($median_end-$median_start-1))," bp (> $indel_reporting_threshold bp)]";
			if (abs (-1* (($T_E-$T_ST-1-2*$bp_window_overlap)-($median_end-$median_start-1)) - $estimated_size) <= $uncertainty) {
				print " Validated_within_uncertainty=$uncertainty ";
				$validated=1;
			}
		}
	}
	if ($strand eq '+/-' or $strand eq '-/+') {
		print " [inversion]";
		print " Validated " if ($ad_hoc_score>0.5);
		$validated=1 if ($ad_hoc_score>0.5);
	} elsif ($strand =~ /{[\+\-\/]}2/) {
		print " [complex ", abs (($T_E-$T_ST-2-2*$bp_window_overlap)-$estimated_size)," bp]";
	}
	if ($gap_warning) {
		print " [gap-warning]";
	}
	if ($missing_seq_warning) {
		print " [missing-sequence-warning]";
	}
	#print "\n";
	return $validated;
}


sub iterative_primer_design_inv {
    my ($infile, $cluster, $chr,$first_start,$target_interval_start,$target_interval_end,$last_end,$estimated_size, $seq_size) =@_;
	my $OK=0;
	my $min_product_size = $number_of_Ns;
	my $max_product_size = $number_of_Ns + 1000;
	my ($left, $right);
	while (!$OK) {
		#-- 1. create input file
		#print STDERR "Running primer3 iteration $chr:$target_interval_start-$target_interval_end with product size $min_product_size-$max_product_size...\n";
		system "./Perl/formatPrimer3_for_SV_validation.pl -i $infile -PRIMER_PRODUCT_SIZE_RANGE $min_product_size-$max_product_size > $infile.prim3_in";
		unless (`cat $infile.prim3_in`) {
			print STDERR "Error #1; problem with ./Perl/formatPrimer3_for_SV_validation.pl ... potential problem: no such file in path!!\n";
			exit
		}
		#print STDERR "./Perl/formatPrimer3_for_SV_validation.pl -i $infile -PRIMER_PRODUCT_SIZE_RANGE $min_product_size-$max_product_size > $infile.prim3_in\n";#XXX
		#print "./Perl/formatPrimer3_for_SV_validation.pl -i $infile -PRIMER_PRODUCT_SIZE_RANGE $min_product_size-$max_product_size > $infile.prim3_in\n";#XXX
		#-- 2. run primer
		system "~/bin/primer3_core < $infile.prim3_in > $infile.prim3_out";
		#-- 3. parse output
		open FH2, "$infile.prim3_out" or die;
		my ($leftP, $rightP);
		while (<FH2>) {
			chomp;
			if ($_ =~ /PRIMER_LEFT_SEQUENCE\=([ACGTacgt]+)/) {
				$left = $1;
			} elsif ($_ =~ /PRIMER_RIGHT_SEQUENCE\=([ACGTacgt]+)/) {
				$right = $1;
			}
		}
		if ($left and $right) {
			my $expected_band_size_L = $median_insert_size + (($max_product_size - $number_of_Ns ) / 2) - int(($target_interval_start-$first_start)/2) - int(($last_end-$target_interval_end)/2);
			my $expected_band_size_S = $expected_band_size_L-2000;
			$expected_band_size_S = 0 if ($expected_band_size_S < 0);
			$expected_band_size_L = 1000 if ($expected_band_size_L < 1000);
			print "LEFT=$left; RIGHT=$right; EXP_BAND_SIZE=$expected_band_size_S-$expected_band_size_L";
			last;
		} else {
			$left=undef; $right=undef;
		}
		#-- 4.. next iteration
		$max_product_size+=1000;
		if ($max_product_size == $seq_size+1000) {
			print "#stopping prematurely, as $max_product_size(selected_max_product_size) did not yield primers --> may wanna improve this by getting more quality (non-repeat)-sequence to left and right!!\n";
			last;
		} elsif ($max_product_size > $seq_size) {
			$max_product_size = $seq_size;
		}
		close FH2;																													
	}	#die;
}
																																																																																																											
sub parse_previous_validation_lists {
        my (@list_of_previous_SVs_validated) = (@_);
		foreach my $file (@list_of_previous_SVs_validated) {
		if ($file =~ /\.gz$/) {
		open FH, "gunzip -c $file |" or die "cannot open $file: $!\n";
		} else {
		open FH, "$file" or die "cannot open $file: $!\n";
		}
		my $hg18 = 0;
		if ($file=~/hg17/ or $file=~/ncbi35/) {
			$hg18 = 0;
			print STDERR "parsing $file (hg17) ";
		} else {  																													                        print STDERR "parsing $file (hg18) ";
		    $hg18=1;
		}
		my $cnt++;
		my ($chr, $start, $end);
		while (<FH>) {
			chomp;
			next unless ($_);
			next if ($_ =~ /^Type/ or $_ =~ /^Redun/ or $_ =~ /^ID/);
			next if ($_ =~ /chr[Mm][Tt]/);
			if ($_=~/(chr[a-zA-Z_0-9]+)\:([0-9]+)\-([0-9]+)/) {
				($chr,$start,$end) = ($1,$2,$3);
				($chr,$start,$end) = &liftover_one_by_one ($chr,$start,$end) unless ($hg18);
				next unless ($chr =~ /^chr/);
				my $type="";
				if ($_=~/DEL/ or $_ =~ /eleti/) {
					$type="DEL";
				} elsif ($_=~/INS/ or $_ =~ /nserti/) {
					$type="INS";
				} elsif ($_=~/INV/ or $_ =~ /nvers/) {
					$type="INV";
				} else {
					print STDERR "unknown type: $_\n";
					die;
				}
				$presence{$type}{$chr}=1;
				push (@{$STARTs{$type}{$chr}}, $start);
				push (@{$ENDs{$type}{$chr}}, $end);
				my (@col) = split (/,/);
				push (@{$IDs{$type}{$chr}}, $col[0]);
				$cnt++;
			} elsif ($_=~/(chr[a-zA-Z_0-9]+)\,([0-9]+)\-([0-9]+)/) {
				($chr,$start,$end) = ($1,$2,$3);
				($chr,$start,$end) = &liftover_one_by_one ($chr,$start,$end) unless ($hg18);
				next unless ($chr =~ /^chr/);
				my $type="";
				if ($_=~/DEL/ or $_ =~ /eleti/) {
					$type="DEL";
				} elsif ($_=~/INS/ or $_ =~ /nserti/) {
					$type="INS";
				} elsif ($_=~/INV/ or $_ =~ /nvers/) {
					$type="INV";
				} else {
					print STDERR "unknown type: $_\n";
					die;
				}
				$presence{$type}{$chr}=1;
				push (@{$STARTs{$type}{$chr}}, $start);
				push (@{$ENDs{$type}{$chr}}, $end);
				my (@col) = split (/,/);
				push (@{$IDs{$type}{$chr}}, $col[0]);
				$cnt++;
			} else {
				print STDERR "ignoring line ($file): $_\n" unless ($file eq "Human/NA15510/validation_candidates/pcr_primers_initial_try_hg18.csv.gz");
			}
		}
		close FH;
		print STDERR " ... $cnt entries.\n";
	}
}

sub intersect {
    my ($type,$chr,$start, $end) = @_;
	my $overlap = 0;
	if (exists($presence{$type}{$chr})) {
		for (my $i=0; $i<@{$STARTs{$type}{$chr}}; $i++) {
			#print STDERR "comparing $type,$chr,$start, $end with $chr:$STARTs{$type}{$chr}[$i]-$ENDs{$type}{$chr}[$i]\n";
			if ($type eq 'DEL' or $type eq 'INS') { #partial overlaps
				if (    ($STARTs{$type}{$chr}[$i]<=$start and $start <= $ENDs{$type}{$chr}[$i])
				or ($start<=$STARTs{$type}{$chr}[$i] and $STARTs{$type}{$chr}[$i]<=$end) ) {
				#size_check
					if ( ($ENDs{$type}{$chr}[$i]-$STARTs{$type}{$chr}[$i])*$max_size_difference <= ($end-$start) and ($end-$start)*$max_size_difference <= ($ENDs{$type}{$chr}[$i]-$STARTs{$type}{$chr}[$i]) ) {
						$overlap = "$chr:$STARTs{$type}{$chr}[$i]-$ENDs{$type}{$chr}[$i]($IDs{$type}{$chr}[$i])";
						last;
					}
				}
			} elsif ($type eq 'INV') { #full overlap;
				if (    ($STARTs{$type}{$chr}[$i]<=$start and $end <= $ENDs{$type}{$chr}[$i])
				or ($start<$STARTs{$type}{$chr}[$i] and $ENDs{$type}{$chr}[$i]<$end) ) {
					if ( ($ENDs{$type}{$chr}[$i]-$STARTs{$type}{$chr}[$i])*$max_size_difference <= ($end-$start) and ($end-$start)*$max_size_difference <= ($ENDs{$type}{$chr}[$i]-$STARTs{$type}{$chr}[$i]) ) {
						$overlap = "$chr:$STARTs{$type}{$chr}[$i]-$ENDs{$type}{$chr}[$i]($IDs{$type}{$chr}[$i])";
						last;
					}
				}
			}
		}
	} else {
		delete ($presence{$type}{$chr});
	}
	#print "returning $overlap...\n";
	return ($overlap);
}


sub liftover_one_by_one {

    #-- 1st left side
	#print STDERR "doing liftover!\n";
	open WH, "> $$\_liftover.bed" or die "cannot write to $$\_liftover.bed:$!\n";
	print WH "$_[0]\t$_[1]\t", $_[1]+1,"\n";
	#print STDERR "--> $_[0]\t$_[1]\t$_[2]\n";
	close WH;
	system "(~/bin/liftOver/liftOver $$\_liftover.bed  ~/bin/liftOver/hg17ToHg18.over.chain $$\_liftover_hg18.bed  unmapped\_$$\_example.bed) 2>/dev/null";
	open LOH, "$$\_liftover_hg18.bed" or die "cannot open $$\_liftover_hg18.bed: $!\n";
	my $line = <LOH>;
	system "rm -f $$\_liftove* unmapped\_$$* ";
	unless ($line) {
		print STDERR "Could not lift: $_[0]:$_[1]-$_[2] ";
		return (-9,-9,-9);
	}
	chomp $line;
	my ($n_chr,$n_start,undef) = split (/\t/, $line);
	close LOH;
	
	#-- 2nd right side
	open WH, "> $$\_liftover.bed" or die "cannot write to $$\_liftover.bed:$!\n";
	print WH "$_[0]\t",$_[2]-1,"\t", $_[2],"\n";
	#print STDERR "--> $_[0]\t$_[1]\t$_[2]\n";
	close WH;
	system "(~/bin/liftOver/liftOver $$\_liftover.bed  ~/bin/liftOver/hg17ToHg18.over.chain $$\_liftover_hg18.bed  unmapped\_$$\_example.bed) 2>/dev/null";
	open LOH, "$$\_liftover_hg18.bed" or die "cannot open $$\_liftover_hg18.bed: $!\n";
	$line = <LOH>;
	system "rm -f $$\_liftover* unmapped\_* ";
	unless ($line) {
		print STDERR "Could not lift: $_[0]:$_[1]-$_[2] ";
		return (-9,-9,-9);																															    }
	chomp $line;
	my ($test_chr,undef, $n_end) = split (/\t/, $line);
	close LOH;
	unless (($test_chr eq $n_chr) and ($n_chr eq $_[0])) {
		print STDERR "unmapped: left and right map to different chromosomes!\n";
		die;
		return (-9,-9,-9);
	}
	#-- 3rd return
	#print STDERR "Lifted $_[0]:$_[1]-$_[2] to $n_chr:$n_start-$n_end\n";
	return ($n_chr,$n_start,$n_end);
}
																																																
