#!/usr/bin/perl -w
use strict;

my $tolernace =3000; #this torernace coefficient is based on the original 454-PEM protocol used in Korbel et al., Science 2007
unless ($ARGV[2]) {
	print STDERR "use together with maq, i.e.: \n";
	print STDERR "  bin/maq mapview [-bN] aln.map  |  Perl/Maq-Solexa-Solid2PEMer.pl  min_single_end_mapping_quality[e.g.:0]  min_mapping_quality[e.g.:20] min_discordant[e.g.:2000] max_SV_size[e.g.:200000]\n";
	print STDERR "  -->current slight limitation (will be fixed in later releases): inversions only picked up if read-span is discordant...\n";
	print STDERR "  test whether coordinates correctly adapted...\n";
	print STDERR "  translocations are currently ignored...\n";
	exit;
}

my ($min_single_end_mapping_quality, $min_mapping_quality, $min_discordant, $max_SV_size) = @ARGV;

my (%ENTRY, $read_id);
print "CIRCLE_ID(PSEUDO-454-FORMAT;MIN-SINGLE_END_MAP-QUAL=$min_single_end_mapping_quality;MIN-MAP-QUAL=$min_mapping_quality;MIN-DISCORDANT=$min_discordant;MAX-SV-SIZE=$max_SV_size)	PLACEMENT_SCORE	CHR_A	START_A	END_A	STRAND_A	PERC_SEQID_UNWEIGHED_A	LENGTH_A	CHR_B	START_B	END_B	STRAND_B	PERC_SEQID_UNWEIGHED_B	LENGTH_B	CALL\n";
while (<STDIN>) {
	chomp;
	my ($end_id, $chromosome, $position, $strand, $insert_size_from_the_outer_coordinates_of_a_pair, $paired_flag, $mapping_quality, $single_end_mapping_quality, $alternative_mapping_quality, $number_of_mismatches_of_the_best_hit, $sum_of_qualities_of_mismatched_bases_of_the_best_hit, $number_of_0_mismatch_hits_of_the_first_24bp, $number_of_1_mismatch_hits_of_the_first_24bp_on_the_reference, $length_of_the_read, $read_sequence_and_its_quality) = split (/\t/);
	next unless (abs($insert_size_from_the_outer_coordinates_of_a_pair) >= $min_discordant);
	next unless (abs($insert_size_from_the_outer_coordinates_of_a_pair) < ($max_SV_size + $tolernace));
	($read_id) = split (/\//, $end_id);
	if (($single_end_mapping_quality < $min_single_end_mapping_quality) or ($mapping_quality < $min_mapping_quality)) {#ignoring mapping qual
		delete ($ENTRY{$read_id}) if ($ENTRY{$read_id});
		next;
	}
	#print "$_\n";
	#print "$read_id\n";
	if ($ENTRY{$read_id}) {
		my $posA2=$position+$length_of_the_read;
		my ($chromosome_prev, $position_prev,$posA2_prev, $strand_prev, $single_end_mapping_quality_prev, $length_of_the_read_prev) = split (/\t/, $ENTRY{$read_id});
		if ($chromosome_prev ne $chromosome) {
			delete ($ENTRY{$read_id});
			next; #exclude translocations
		}
		my $call = '[predicted deletion in sample]';
		if ($strand_prev eq $strand) {
			$call = '[predicted inversion in sample]';
			$strand = '-';
			$strand_prev = '+';
		} else {
			$strand_prev = '+';
			$strand = '+';
		}
		#print "$read_id\t0.78\tchr$chromosome_prev\t$position_prev\t$posA2_prev\t$strand_prev\t99.$single_end_mapping_quality_prev\t$length_of_the_read_prev\tchr$chromosome\t$position\t$posA2\t$strand\t99.$single_end_mapping_quality\t$length_of_the_read\t$call\n";
		print "$read_id\t0.78\tchr$chromosome\t$position\t$posA2\t$strand\t99.$single_end_mapping_quality\t$length_of_the_read\tchr$chromosome_prev\t$position_prev\t$posA2_prev\t$strand_prev\t99.$single_end_mapping_quality_prev\t$length_of_the_read_prev\t$call\n";
		delete ($ENTRY{$read_id});
	} else {
		my $posA2=$position+$length_of_the_read;
		$ENTRY{$read_id} = "$chromosome\t$position\t$posA2\t$strand\t$single_end_mapping_quality\t$length_of_the_read";
	}
}
