#!/usr/bin/env python

import gzip, imp, optparse, os, os.path, sys

stdE = sys.stderr

def read_infile(infile, config):
    if infile.endswith('.gz'):
        f = gzip.GzipFile(infile)
    else:
        f = open(infile)

    print >>stdE, 'Reading %s ....'%infile

    infile = os.path.basename(infile)

    batch, buf, count = 0, [], 0
    for l in f:
        if l[0] == '>':
            if count == config.package_size:
                if buf: open('%s/%s.%d.fa'%(config.tmp_dir, infile, batch), 'w').write(''.join(buf))
                batch, buf, count = batch+config.package_size, [], 0
            count += 1
        buf.append(l)
    if buf: open('%s/%s.%d.fa'%(config.tmp_dir, infile, batch), 'w').write(''.join(buf))

    print >>stdE, '%d sequences...'%(batch+count)

    return batch+count

def start_batches(infile, number_of_sequences, config):
    print >>stdE, 'Starting processes...'
    
    if config.runBatch: jobFile = open('%s/jobs'%config.tmp_dir, 'w')

    wd = os.getcwd()
    baseCmd = '%(scriptPath)s/Paired_End_Batch_Nodes.py %(userConfig)s %(tmp_dir)s/%(infile)s.%%(i)d.fa %%(i)d %%(end)d'%{
        'infile': os.path.basename(infile),
        'tmp_dir': config.tmp_dir,
        'scriptPath': config.scriptPath,
        'userConfig': userConfigOpt}
    
    for i in xrange(0, number_of_sequences, config.package_size):
        cmd = baseCmd%{'end': min(i+config.package_size-1, number_of_sequences-1), 'i': i}
        if config.runBatch:
            run = '"\
( cd %(wd)s ; \
touch %(tmp_dir)s/stamp/%(i)d.Start ; \
( %(cmd)s ) > %(tmp_dir)s/log/%(i)d.log 2>&1 ; \
touch %(tmp_dir)s/stamp/%(i)d.Stop )"'%{'cmd': cmd, 'i': i, 'tmp_dir': config.tmp_dir, 'wd': wd}
            print >>jobFile, run
        else:
            # this branch NOT tested!
            print >>stdE, cmd+' ...\n'
            os.system(cmd)

#--- main
ops = optparse.OptionParser()
ops.description = 'Run paired end pipeline'
ops.add_option('-c', '--config', help='override default configuration using values in FILE', metavar='FILE')
ops.set_usage('%prog [options] infile')

oArgs, pArgs = ops.parse_args()

if len(pArgs) != 1:
    ops.print_help()
    sys.exit(1)

infile = pArgs[0]
config = imp.load_source('configData', os.path.dirname(__file__)+'/configPepDefault.py') # establish defaults
userConfigOpt = ''
if oArgs.config:
    config = imp.load_source('configData', oArgs.config)     # allow overrides.
    userConfigOpt = '-c '+os.path.abspath(oArgs.config)
    
for d in ['fa', 'log', 'stamp', 'call',    'discard',    'megablast',    'needle',    'placement', ]:
    p = config.tmp_dir+'/'+d
    if not os.path.exists(p): os.mkdir(p)

number_of_sequences = read_infile(infile, config)
start_batches(infile, number_of_sequences, config)

