
import mmap, os

# this code assumes a file with one definition line, followed by lines of equal length containing nts (the
# last line may be shorter). it also assumes that the line separator is a single character!

class mmapChr:
    def __init__(self, chr, fileName):
        self.chr = chr
        self.fd = os.open(fileName, os.O_RDWR)
        self.size = os.fstat(self.fd)[6]
        self.mmap = mmap.mmap(self.fd, self.size, mmap.MAP_PRIVATE, mmap.PROT_READ)
        self.mmap.readline()
        self.dataStart = self.mmap.tell()
        self.mmap.readline()
        self.dataBytesPerLine = self.mmap.tell() - self.dataStart - 1 # for new line -- UNIXism
        self.numSyms = self.size - self.dataStart
        self.numSyms -= divmod(self.numSyms, self.dataBytesPerLine+1)[0]
        
    def close(self):
        self.mmap.close()
        os.close(self.fd)
        
    def getSeq(self, start, stop):
        (startsAtLine, startOffset) = divmod(start-1, self.dataBytesPerLine)
        (endsAtLine, endOffset) = divmod(stop, self.dataBytesPerLine)
        
        self.mmap.seek(startsAtLine*(self.dataBytesPerLine+1) + startOffset + self.dataStart)

        if startsAtLine == endsAtLine:
            return self.mmap.read(endOffset - startOffset)

        seq = self.mmap.read(self.dataBytesPerLine - startOffset)
        self.mmap.read(1) # skip new line
        for i in xrange(endsAtLine - startsAtLine - 1):
            seq += self.mmap.read(self.dataBytesPerLine)
            self.mmap.read(1)
        seq += self.mmap.read(endOffset)

        return seq
